import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;

public class ClientTalkerThread extends Thread {
	private static int num_clients = 0;
	private int this_client_number = ++num_clients;
    private final SimpleLogger logger = new SimpleLogger("Julbordsservern: ClientTalkerThread " + this_client_number);
	private Socket socket;
	private BufferedReader from_client;
    private PrintWriter to_client;
	
	public ClientTalkerThread(Socket socket) {
		this.socket = socket;
		try {
			this.from_client = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			this.to_client = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
			// true: PrintWriter is line buffered
		}
		catch (IOException e) {
        	logger.log("IOException in constructor: " + e);
			e.printStackTrace();
		}
	}

	@Override
	public void run() {
		try {
			logger.log("Waiting for name from client...");
			String name = from_client.readLine();
			logger.log("Got name from client: [" + name + "]");
			String toplist = Julbordsservern.add_julbord(name);
			to_client.print(toplist);
			to_client.flush();
			to_client.close();
			from_client.close();
			socket.close();
		} catch (IOException e) {
        	logger.log("IOException in run: " + e);
			e.printStackTrace();
		}
	}
} // ClientTalker
