
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;

class Player {
	public Player(String name) {
		this.name = name;
		this.num_julbord = 0;
	}
	public final String name;
	public int num_julbord;
}

class ComparePlayers implements Comparator<Player> {
	@Override
	public int compare(Player p1, Player p2) {
		return p2.num_julbord - p1.num_julbord;
	}
}

public class Julbordsservern {
	private static final int PORT = 2003;
	
	private static ArrayList<Player> toplist = new ArrayList<Player>();
	private static HashMap<String, Player> lookup = new HashMap<String, Player>();
	final static ComparePlayers the_comparator = new ComparePlayers();
	
	public static synchronized String add_julbord(String name) {
		if (! lookup.containsKey(name)) {
			final Player newplayer = new Player(name);
			toplist.add(newplayer);
			lookup.put(name, newplayer);
		}
		final Player player = lookup.get(name);
		player.num_julbord++;
		toplist.sort(the_comparator);
		
		String result = "";
		final int toplistlength = min(toplist.size(), 3); 
		for (int i = 0; i < toplistlength; ++i) {
			Player listed_player = toplist.get(i);
			result += (i + 1) + ". " + listed_player.name + ": " + listed_player.num_julbord + "\n";
		}
		return result;
	}
	
	private static int min(int i1, int i2) {
		if (i1 < i2)
			return i1;
		else
			return i2;
	}

	public static void main(String[] args) {
		final SimpleLogger logger = new SimpleLogger("Julbordsservern");

        try {
            ServerSocket s = new ServerSocket(PORT);
            logger.log("Server-socketen: " + s);
            logger.log("Servern lyssnar...");
            
            while(true) {
                logger.log("Vntar p uppkoppling frn klient...");
                // Blocks until a connection occurs:
                final Socket socket = s.accept();
                logger.log("Uppkoppling frn klient accepterad.");
                logger.log("Den nya socketen: " + socket);
                final ClientTalkerThread c = new ClientTalkerThread(socket);
                c.start();
            }
        } catch (IOException e) {
        	logger.log("IOException: " + e);
            e.printStackTrace();
        }
	} // main
} // Julbordsservern
